From 5a14ef5a30f324d0ab4ace184c14425420c60b6f Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Fri, 21 Aug 2020 15:17:37 +0800
Subject: [PATCH] add ntpdate build shell script

---
 3rdparty/mosquitto/build.sh |    4 +-
 3rdparty/ntpdate/build.sh   |   98 +++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 100 insertions(+), 2 deletions(-)

diff --git a/3rdparty/mosquitto/build.sh b/3rdparty/mosquitto/build.sh
index ddcb7de..b925b09 100755
--- a/3rdparty/mosquitto/build.sh
+++ b/3rdparty/mosquitto/build.sh
@@ -70,8 +70,8 @@
     msg_banner "Start cross compile $SRC_NAME "
 
     if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
-        wget https://mosquitto.org/files/source/${SRC_NAME}.${PACK_SUFIX}
-        #wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+        #wget https://mosquitto.org/files/source/${SRC_NAME}.${PACK_SUFIX}
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
 
         check_result "ERROR: download ${SRC_NAME} failure"
     fi
diff --git a/3rdparty/ntpdate/build.sh b/3rdparty/ntpdate/build.sh
new file mode 100755
index 0000000..b9c1f48
--- /dev/null
+++ b/3rdparty/ntpdate/build.sh
@@ -0,0 +1,98 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile ntpdate for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PREFIX_PATH=`pwd`/../install/
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+
+function compile_ntpdate()
+{
+    SRC_NAME=ntp-4.2.6p5
+    PACK_SUFIX=tar.gz
+
+    if [ -f ${PREFIX_PATH}/bin/ntpdate ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start donwload $SRC_NAME "
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        #wget https://www.eecis.udel.edu/~ntp/ntp_spool/ntp4/ntp-4.2/${SRC_NAME}.${PACK_SUFIX}
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} --disable-ipv6 --disable-tickadj --disable-tick \
+        --disable-ntp-signd 
+
+    check_result "ERROR: configure ${SRC_NAME} failure"
+
+    make && make install
+    check_result "ERROR: compile ${SRC_NAME} failure"
+
+
+    ${STRIP} ${PREFIX_PATH}/bin/ntpdate
+
+    cd -
+}
+
+export_cross
+
+compile_ntpdate
+
+

--
Gitblit v1.9.1